View Issue Details

IDProjectCategoryView StatusLast Update
0004020GNUnetcadet servicepublic2018-06-07 00:24
ReporterChristian GrothoffAssigned ToBart Polot 
PrioritynormalSeveritycrashReproducibilityhave not tried
Status closedResolutionfixed 
Platformi7OSDebian GNU/LinuxOS Versionsqueeze
Product VersionSVN HEAD 
Target Version0.11.0pre66Fixed in Version0.11.0pre66 
Summary0004020: assertion failure at gnunet-service-cadet_connection.c:2148
DescriptionBasically, the 'c->state' is already 'DESTROYED':

#3 0x0000000000418437 in GCC_handle_confirm (cls=0x0, peer=0x7fff8d734954, message=0x7fff8d734974)
    at gnunet-service-cadet_connection.c:2148
(gdb) print *c
$1 = {t = 0x0, fwd_fc = {c = 0xae8a90, queue_n = 0, queue_max = 11, last_pid_sent = 4294967295, last_pid_recv = 4294967295,
    recv_bitmap = 0, last_ack_sent = 0, last_ack_recv = 0, poll_task = 0x0, poll_time = {rel_value_us = 1000000}, poll_msg = 0x0,
    ack_msg = 0x0}, bck_fc = {c = 0xae8a90, queue_n = 0, queue_max = 11, last_pid_sent = 4294967295, last_pid_recv = 4294967295,
    recv_bitmap = 0, last_ack_sent = 0, last_ack_recv = 0, poll_task = 0x0, poll_time = {rel_value_us = 1000000}, poll_msg = 0x0,
    ack_msg = 0x0}, perf = 0x0, id = {bits = "u\231[\022\322{@\257\274\330\300\347b$P\373(\271f;\030\271/\330j<Q*\255q\361|"},
  path = 0xac9b60, fwd_maintenance_task = 0xad1f70, bck_maintenance_task = 0xae62b0, maintenance_q = 0x0, next_peer = 0xadeb10,
  prev_peer = 0xa74910, state = CADET_CONNECTION_DESTROYED, own_pos = 1, pending_messages = 6, destroy = 1, was_removed = 0,
  create_retry = 0, check_duplicates_task = 0x0}
Steps To ReproduceCore dump found on gnunet9@gnunet.org
Additional Information#0 0x00007f95c01fe107 in __GI_raise (sig=sig@entry=6) at ../nptl/sysdeps/unix/sysv/linux/raise.c:56
#1 0x00007f95c01ff4e8 in __GI_abort () at abort.c:89
#2 0x00007f95c18ce983 in GNUNET_abort_ () at common_logging.c:290
#3 0x0000000000418437 in GCC_handle_confirm (cls=0x0, peer=0x7fff8d734954, message=0x7fff8d734974)
    at gnunet-service-cadet_connection.c:2148
#4 0x00007f95c149f4a7 in main_notify_handler (cls=0xa600f0, msg=0x7fff8d734950) at core_api.c:906
#5 0x00007f95c18c92ce in receive_task (cls=0xa602f0, tc=0x7fff8d734a60) at client.c:623
#6 0x00007f95c190b6c6 in run_ready (rs=0xa5ec00, ws=0xa5ec90) at scheduler.c:587
#7 0x00007f95c190bfba in GNUNET_SCHEDULER_run (task=0x7f95c19189c4 <service_task>, task_cls=0x7fff8d734e00) at scheduler.c:868
#8 0x00007f95c191a6d6 in GNUNET_SERVICE_run (argc=3, argv=0x7fff8d735098, service_name=0x43c4ea "cadet",
    options=GNUNET_SERVICE_OPTION_NONE, task=0x43569f <run>, task_cls=0x0) at service.c:1503
#9 0x0000000000435a0e in main (argc=3, argv=0x7fff8d735098) at gnunet-service-cadet.c:174
TagsNo tags attached.

Activities

Christian Grothoff

2015-10-23 15:25

manager   ~0009781

On another system with valgrind:

Oct 23 14:49:48-556661 cadet-30848 ERROR Assertion failed at gnunet-service-cadet_connection.c:2150.
==30848==
==30848== Process terminating with default action of signal 6 (SIGABRT): dumping core
==30848== at 0x663A107: raise (raise.c:56)
==30848== by 0x663B4E7: abort (abort.c:89)
==30848== by 0x5057A30: GNUNET_abort_ (common_logging.c:290)
==30848== by 0x418684: GCC_handle_confirm (gnunet-service-cadet_connection.c:2150)
==30848== by 0x54D84D0: main_notify_handler (core_api.c:906)
==30848== by 0x50522E8: receive_task (client.c:623)
==30848== by 0x50949FC: run_ready (scheduler.c:587)
==30848== by 0x509530E: GNUNET_SCHEDULER_run (scheduler.c:868)
==30848== by 0x50A3B4A: GNUNET_SERVICE_run (service.c:1503)
==30848== by 0x435D1A: main (gnunet-service-cadet.c:174)
==30848==
==30848== HEAP SUMMARY:
==30848== in use at exit: 225,035 bytes in 3,518 blocks
==30848== total heap usage: 119,634,891 allocs, 119,631,373 frees, 3,818,312,302 bytes allocated
==30848==
==30848== LEAK SUMMARY:
==30848== definitely lost: 0 bytes in 0 blocks
==30848== indirectly lost: 0 bytes in 0 blocks
==30848== possibly lost: 0 bytes in 0 blocks
==30848== still reachable: 225,035 bytes in 3,518 blocks
==30848== suppressed: 0 bytes in 0 blocks
==30848== Rerun with --leak-check=full to see details of leaked memory
==30848==
==30848== For counts of detected and suppressed errors, rerun with: -v
==30848== ERROR SUMMARY: 0 errors from 0 contexts (suppressed: 0 from 0)

Note that there were no other valgrind errors prior to the crash.

amatus

2015-10-23 16:07

developer   ~0009782

Found this in a core file for rev 36559:

Program terminated with signal SIGABRT, Aborted.
#0 0xb6edbddc in __GI_raise (sig=sig@entry=6)
    at ../nptl/sysdeps/unix/sysv/linux/raise.c:56
56 ../nptl/sysdeps/unix/sysv/linux/raise.c: No such file or directory.
(gdb) bt
#0 0xb6edbddc in __GI_raise (sig=sig@entry=6)
    at ../nptl/sysdeps/unix/sysv/linux/raise.c:56
#1 0xb6edd463 in __GI_abort () at abort.c:89
#2 0xb7122096 in GNUNET_abort_ () at common_logging.c:290
#3 0x08069f31 in GCC_handle_confirm (cls=0x0, peer=0xbfbe5ff4,
    message=0xbfbe6014) at gnunet-service-cadet_connection.c:2150
#4 0xb70c75ea in main_notify_handler (cls=0xb2802d40, msg=0xbfbe5ff0)
    at core_api.c:906
#5 0xb7117c37 in receive_task (cls=0xb4204d90, tc=0xbfbe6130) at client.c:623
#6 0xb71a15bc in run_ready (rs=0xb2c03370, ws=0xb2c032a0) at scheduler.c:587
#7 0xb71a22da in GNUNET_SCHEDULER_run (task=0xb71bc1be <service_task>,
    task_cls=0xbfbe6690) at scheduler.c:868
#8 0xb71bf339 in GNUNET_SERVICE_run (argc=7, argv=0xbfbe6914,
    service_name=0x809f9a0 "cadet", options=GNUNET_SERVICE_OPTION_NONE,
    task=0x8093f87 <run>, task_cls=0x0) at service.c:1503
#9 0x0809421f in main (argc=7, argv=0xbfbe6914) at gnunet-service-cadet.c:174
(gdb) f 3
#3 0x08069f31 in GCC_handle_confirm (cls=0x0, peer=0xbfbe5ff4,
    message=0xbfbe6014) at gnunet-service-cadet_connection.c:2150
2150 gnunet-service-cadet_connection.c: No such file or directory.
(gdb) print *c
$1 = {t = 0x0, fwd_fc = {c = 0x9e691cc0, queue_n = 0, queue_max = 11,
    last_pid_sent = 0, last_pid_recv = 4294967295, recv_bitmap = 0,
    last_ack_sent = 0, last_ack_recv = 0, poll_task = 0x9ec60020, poll_time = {
      rel_value_us = 1000000}, poll_msg = 0x0, ack_msg = 0x0}, bck_fc = {
    c = 0x9e691cc0, queue_n = 0, queue_max = 11, last_pid_sent = 4294967295,
    last_pid_recv = 0, recv_bitmap = 1, last_ack_sent = 10, last_ack_recv = 0,
    poll_task = 0x0, poll_time = {rel_value_us = 1000000}, poll_msg = 0x0,
    ack_msg = 0x0}, perf = 0x0, id = {
    bits = "\362\375\022?r\332G\345\371\353\200\240\032\r?\256\345\033\304\346\\\371ah\034\215V:\267M\332\317"}, path = 0xaaa24b20,
  fwd_maintenance_task = 0x9f031ac0, bck_maintenance_task = 0xa0836c80,
  maintenance_q = 0x0, next_peer = 0xb4206d10, prev_peer = 0xb4206d80,
  state = CADET_CONNECTION_DESTROYED, own_pos = 2, pending_messages = 1,
  destroy = 1, was_removed = 0, create_retry = 1, check_duplicates_task = 0x0}

Bart Polot

2015-12-09 19:57

manager   ~0009987

Fixed in r36748.

amatus

2015-12-10 15:40

developer   ~0009993

Still seeing this in rev 36750.

Program terminated with signal SIGABRT, Aborted.
#0 0xb7517ddc in __GI_raise (sig=sig@entry=6)
    at ../nptl/sysdeps/unix/sysv/linux/raise.c:56
56 ../nptl/sysdeps/unix/sysv/linux/raise.c: No such file or directory.
(gdb) bt
#0 0xb7517ddc in __GI_raise (sig=sig@entry=6)
    at ../nptl/sysdeps/unix/sysv/linux/raise.c:56
#1 0xb7519463 in __GI_abort () at abort.c:89
#2 0xb76f4000 in GNUNET_abort_ () at common_logging.c:290
#3 0x080591df in GCC_handle_confirm (cls=0x0, peer=0xbfe9f364,
    message=0xbfe9f384) at gnunet-service-cadet_connection.c:2156
#4 0xb76cb26e in main_notify_handler (cls=0x998e1b8, msg=0xbfe9f360)
    at core_api.c:906
#5 0xb76ef7b4 in receive_task (cls=0x99902e8, tc=0xbfe9f414) at client.c:623
#6 0xb772b008 in run_ready (rs=0x999cfd0, ws=0x998d9b0) at scheduler.c:587
#7 0xb772b895 in GNUNET_SCHEDULER_run (task=0xb77363f9 <service_task>,
    task_cls=0xbfe9f640) at scheduler.c:868
#8 0xb7737f97 in GNUNET_SERVICE_run (argc=7, argv=0xbfe9f834,
    service_name=0x806fe2c "cadet", options=GNUNET_SERVICE_OPTION_NONE,
    task=0x806c6cc <run>, task_cls=0x0) at service.c:1503
#9 0x0806c95e in main (argc=7, argv=0xbfe9f834) at gnunet-service-cadet.c:174
(gdb) f 3
#3 0x080591df in GCC_handle_confirm (cls=0x0, peer=0xbfe9f364,
    message=0xbfe9f384) at gnunet-service-cadet_connection.c:2156
2156 gnunet-service-cadet_connection.c: No such file or directory.
(gdb) p *c
$1 = {t = 0x0, fwd_fc = {c = 0x99a09c0, queue_n = 0, queue_max = 11,
    last_pid_sent = 4294967295, last_pid_recv = 4294967295, recv_bitmap = 0,
    last_ack_sent = 0, last_ack_recv = 0, poll_task = 0x0, poll_time = {
      rel_value_us = 1000000}, poll_msg = 0x0, ack_msg = 0x0}, bck_fc = {
    c = 0x99a09c0, queue_n = 0, queue_max = 11, last_pid_sent = 4294967295,
    last_pid_recv = 4294967295, recv_bitmap = 0, last_ack_sent = 0,
    last_ack_recv = 0, poll_task = 0x0, poll_time = {rel_value_us = 1000000},
    poll_msg = 0x0, ack_msg = 0x0}, perf = 0x0, id = {
    bits = "F\272\201\352\217\024e\253,8\210\204\353\311\313\"\215wI\r\334*\320\213\373\201\035`3\313\061\340"}, path = 0x99ae0c8,
  fwd_maintenance_task = 0x99936c8, bck_maintenance_task = 0x9990290,
  maintenance_q = 0x0, next_peer = 0x99a06f8, prev_peer = 0x9991238,
  state = CADET_CONNECTION_ACK, own_pos = 7, pending_messages = 1,
  destroy = 1, was_removed = 0, create_retry = 0, check_duplicates_task = 0x0}

amatus

2015-12-12 16:56

developer   ~0009995

Here's another one in state READY:

(gdb) p *c
$1 = {t = 0x0, fwd_fc = {c = 0x952a700, queue_n = 0, queue_max = 11,
    last_pid_sent = 4294967295, last_pid_recv = 4294967295, recv_bitmap = 0,
    last_ack_sent = 0, last_ack_recv = 0, poll_task = 0x0, poll_time = {
      rel_value_us = 1000000}, poll_msg = 0x0, ack_msg = 0x0}, bck_fc = {
    c = 0x952a700, queue_n = 0, queue_max = 11, last_pid_sent = 4294967295,
    last_pid_recv = 4294967295, recv_bitmap = 0, last_ack_sent = 0,
    last_ack_recv = 0, poll_task = 0x0, poll_time = {rel_value_us = 1000000},
    poll_msg = 0x0, ack_msg = 0x0}, perf = 0x0, id = {
    bits = "Er\241[\335pP\244Q\257-c\v2aX\266HH\220\261\035C\343\343n\016\307+\251\204\370"}, path = 0x9523cc0, fwd_maintenance_task = 0x951cfb0,
  bck_maintenance_task = 0x9529c30, maintenance_q = 0x0,
  next_peer = 0x94df368, prev_peer = 0x94d4f10,
  state = CADET_CONNECTION_READY, own_pos = 4, pending_messages = 1,
  destroy = 1, was_removed = 0, create_retry = 1, check_duplicates_task = 0x0}

amatus

2015-12-12 16:58

developer   ~0009996

Here's another one in state SENT:

(gdb) p *c
$4 = {t = 0x0, fwd_fc = {c = 0x856aea8, queue_n = 0, queue_max = 11,
    last_pid_sent = 4294967295, last_pid_recv = 4294967295, recv_bitmap = 0,
    last_ack_sent = 0, last_ack_recv = 0, poll_task = 0x0, poll_time = {
      rel_value_us = 1000000}, poll_msg = 0x0, ack_msg = 0x0}, bck_fc = {
    c = 0x856aea8, queue_n = 0, queue_max = 11, last_pid_sent = 4294967295,
    last_pid_recv = 4294967295, recv_bitmap = 0, last_ack_sent = 0,
    last_ack_recv = 0, poll_task = 0x0, poll_time = {rel_value_us = 1000000},
    poll_msg = 0x0, ack_msg = 0x0}, perf = 0x0, id = {
    bits = "\213\r\334\230M\001\v\362%`\v\376\357\326\033\363\210\343\005o\235\332c\217q{\377Z\206\373F|"}, path = 0x8552b20,
  fwd_maintenance_task = 0x856bb98, bck_maintenance_task = 0x0,
  maintenance_q = 0x0, next_peer = 0x855be40, prev_peer = 0x855c580,
  state = CADET_CONNECTION_SENT, own_pos = 1, pending_messages = 1,
  destroy = 1, was_removed = 0, create_retry = 0, check_duplicates_task = 0x0}

Bart Polot

2016-03-30 11:19

manager   ~0010337

Fixed in r36961

Issue History

Date Modified Username Field Change
2015-10-23 01:07 Christian Grothoff New Issue
2015-10-23 01:07 Christian Grothoff Status new => assigned
2015-10-23 01:07 Christian Grothoff Assigned To => Bart Polot
2015-10-23 15:25 Christian Grothoff Note Added: 0009781
2015-10-23 16:07 amatus Note Added: 0009782
2015-12-09 19:57 Bart Polot Note Added: 0009987
2015-12-09 19:57 Bart Polot Status assigned => resolved
2015-12-09 19:57 Bart Polot Fixed in Version => SVN HEAD
2015-12-09 19:57 Bart Polot Resolution open => fixed
2015-12-10 15:40 amatus Note Added: 0009993
2015-12-10 15:40 amatus Status resolved => feedback
2015-12-10 15:40 amatus Resolution fixed => reopened
2015-12-10 15:40 amatus Status feedback => assigned
2015-12-12 16:56 amatus Note Added: 0009995
2015-12-12 16:58 amatus Note Added: 0009996
2016-03-30 11:19 Bart Polot Note Added: 0010337
2016-03-30 11:19 Bart Polot Status assigned => resolved
2016-03-30 11:19 Bart Polot Resolution reopened => fixed
2016-06-03 09:20 Christian Grothoff Fixed in Version SVN HEAD => 0.11.0pre66
2018-06-07 00:24 Christian Grothoff Status resolved => closed